<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"comments", "gallery", "format.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha/title=string?id=int&page=page&option=alpha")
	);

	function processGalleryRow(&$row) {

		saneHTML($row, "description");
		format::style($row["description"], $row["author_id"]);

		list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

		$row["ACTIONS"] = new tplButtonBox();
			$row["ACTIONS"]->add(mklink("index.php/module=gallery/action=show_items/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", _l("L_VIEW"), "submit.png"));
		$row["ACTIONS"] = $row["ACTIONS"]->make();
	}

	switch ($action) {
		case "view":

			if ($id) {

				$tpl = new contentBlock();
				$tpl->insert("BLOCK_CONTENT", "gallery/main.view.tpl");

				$q = $db->query("SELECT id, title, description, media_url, media_size, thumbnail_url,
				thumbnail_size, author_id, date_modified, allow_comments, gallery_id
				FROM ".db_table("gallery_item")." WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					$row["NEXT_ITEM"] = gallery::getNextItem($id);
					$row["PREV_ITEM"] = gallery::getPrevItem($id);

					saneHTML($row, "description");
					format::style($row["description"], $row["author_id"]);

					/* media size */
					$media_size = explode("x", $row["media_size"]);
					if (count($media_size) == 2) {
						$larger = conf::getKey("gallery", "item.larger_size", 342, "i");

						// if media size exceeds maximum, using simple scaling
						$media_size[intval($media_size[0]>$larger)] = $media_size[($media_size[0]>$larger)]*$larger/$media_size[intval(!($media_size[0]>$larger))];
						$media_size[intval(!($media_size[0]>$larger))] = $larger;

						list($row["MEDIA.WIDTH"], $row["MEDIA.HEIGHT"]) = $media_size;
					}

					// thumbnail_url
					list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

					$row["media_url"] = relativeLink($row["media_url"]);

					// displaying media in different presentations depending on media type
					$row["MEDIATYPE"] = gallery::guessMediaType($row["media_url"]);

					$tpl->setArray($row);

					$q = $db->query("SELECT id, title FROM ".db_table("gallery")." WHERE id = '{$row["gallery_id"]}'",
					__FILE__, __LINE__);
					$row2 = $db->fetchRow($q);

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=gallery", _l("L_GALLERIES"), "gallery.png"));
						$actions->add(mklink("index.php/module=gallery/action=show_items/title=".urlTitleEncode($row2["title"])."?id={$row2["id"]}", $row2["title"], "gallery.png"));
						$actions->add(mklink(gallery::getPrevItem($row["id"]), _l("L_PREV"), "back.png"));
						$actions->add(mklink(gallery::getNextItem($row["id"]), _l("L_NEXT"), "forward.png"));
					$actions = $actions->make();

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"	=> $row["title"],
							"BLOCK_ICON"	=> mkIcon("gallery.png", 16),
							"PAGE"			=> $page,
							"ACTIONS"		=> $actions
						)
					);

					$mcBuff = $tpl->make();
				}

			} else {
				$mcBuff = accessDenied();
			}
		break;
		case "show_items": case "items":
			if ($id) {
				$tpl = new contentBlock();

				$tpl->insert("BLOCK_CONTENT", "gallery/main.show_items.tpl");

				$q = $db->query("SELECT
				id, title, description, thumbnail_url, thumbnail_size, auth_access
				FROM ".db_table("gallery")."
				WHERE id = '{$id}'
				ORDER BY title ASC",
				__FILE__, __LINE__);

				$row = $db->fetchRow($q);

				if ($db->numRows($q) && gauth($row["auth_access"])) {

					// subgalleries
					$gallery_lock = "(id = '".implode("' OR id ='", gallery::getAllowedGalleries($row["id"]))."')";

					$q2 = $db->query ("SELECT
					id, title, description, thumbnail_url, thumbnail_size, author_id, date_modified
					FROM ".db_table("gallery")."
					WHERE {$gallery_lock}",
					__FILE__, __LINE__);

					while ($row2 = $db->fetchRow($q2)) {

						processGalleryRow($row2);

						$row2["LINK"] = urlEvalPrototype("index.php/module=gallery/action=show_items/title=".urlTitleEncode($row2["title"])."?id={$row2["id"]}");

						$tpl->setArray($row2, "GALLERY");
						$tpl->saveBlock("GALLERY");
					}

					// items for this gallery
					$pager = $db->pager (
						"SELECT id FROM ".db_table("gallery_item")."
						WHERE gallery_id = '{$row["id"]}'",
						"index.php/module=gallery/action=show_items/title=".urlTitleEncode($row["title"])."?id={$row["id"]}&page=%p",
						$page, conf::getkey("gallery", "items_per_page")
					);

					$q2 = $db->query("SELECT id, title, description, thumbnail_url, thumbnail_size,
					date_modified, author_id, allow_comments
					FROM ".db_Table("gallery_item")."
					WHERE gallery_id = '{$row["id"]}' {$pager["sql"]}", __FILE__, __LINE__);

					while ($row2 = $db->fetchRow($q2)) {
						saneHTML($row2, "description");
						format::style($row2["description"], $row2["author_id"]);

						$row2["ITEM_LINK"] = urlEvalPrototype("index.php/module=gallery/action=view/title=".urlTitleEncode($row2["title"])."?id={$row2["id"]}");
						list($row2["THUMBNAIL.WIDTH"], $row2["THUMBNAIL.HEIGHT"]) = explode("x", $row2["thumbnail_size"]);

						$tpl->setArray($row2, "ITEM");
						$tpl->saveBlock("ITEM");
					}

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=gallery", _l("L_GALLERIES"), "gallery.png"));
					$actions = $actions->make();

					$tpl->setArray ($row);
					$tpl->setArray (
						Array (
							"BLOCK_TITLE"		=> $row["title"],
							"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
							"ACTIONS"			=> $actions,
							"PAGER"				=> $pager["html"]
						)
					);

					$mcBuff = $tpl->make();
				} else {
					$mcBuff = accessDenied();
				}
			}
		break;
		default:

			$gallery_lock = "(id = '".implode("' OR id ='", gallery::getAllowedGalleries())."')";

			$pager = $db->pager (
				"SELECT id FROM ".db_table("gallery")."
				WHERE {$gallery_lock}",
				"index.php/module=gallery?page=%p", $page, conf::getKey("gallery", "items_per_page")
			);

			$q = $db->query("SELECT
			id, title, description, thumbnail_url, thumbnail_size, author_id, date_modified
			FROM ".db_table("gallery")." WHERE {$gallery_lock} ORDER BY
			title ASC {$pager["sql"]}", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "gallery/main.default.tpl");

				while ($row = $db->fetchRow($q)) {

					processGalleryRow($row);

					$row["LINK"] = urlEvalPrototype("index.php/module=gallery/action=show_items/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");

					$tpl->setArray($row, "GALLERY");
					$tpl->saveBlock("GALLERY");
				}

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_GALLERY"),
						"BLOCK_SUBTITLE"	=> _l("L_GALLERIES"),
						"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
						"PAGER"				=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
	}

?>