<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Gallery {
		function create_menu() {
			return false;
		}
		function configure() {
			conf::getKey("gallery", "items_per_page", 8, "i");
			conf::getKey("gallery", "allow_user_comments", 1, "b");
			conf::getKey("gallery", "items_per_admin_page", 24, "i");
			conf::getKey("gallery", "thumbnail.longest_side", 140, "i");
			conf::getkey("gallery", "default_size", "512x384", "s");
		}
		function install() {
			$db =& $GLOBALS["db"];

			$db->query("
			CREATE TABLE ".db_table("gallery")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(ID),
				gallery_id SMALLINT (5) UNSIGNED NOT NULL default '0',
				title VARCHAR (255),
				description TEXT,
				status ENUM('0','1') NOT NULL default '1',
				thumbnail_url VARCHAR (255),
				thumbnail_size VARCHAR (32),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				auth_access VARCHAR (255)
			)
			", __FILE__, __LINE__, true);

			$db->query("
			CREATE TABLE ".db_table("gallery_item")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				gallery_id SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (255),
				description TEXT,
				thumbnail_url VARCHAR (255),
				thumbnail_size VARCHAR (32),
				media_url VARCHAR (255),
				media_size VARCHAR (32),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				allow_comments ENUM('0','1') NOT NULL default '1'
			)
			", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["gallery"], "gallery", "*", $GLOBALS["cgdb"]["gallery"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("gallery"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("gallery_item"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			if (Packages::checkVersion("0.5.9", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("gallery")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("gallery_item")."
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
			if (packages::checkVersion("0.6.6", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("gallery")."
					CHANGE COLUMN gallerylink gallery_id SMALLINT (5) UNSIGNED NOT NULL default '0',
					CHANGE COLUMN thumbnail thumbnail_url VARCHAR (255),
					CHANGE COLUMN thumbnailsize thumbnail_size VARCHAR (32),
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime,
					ADD COLUMN date_modified TIMESTAMP(19) after date_created
				", __FILE__, __LINE__);

				$db->query("UPDATE ".db_table("gallery")." SET
				date_created = FROM_UNIXTIME(creationtime),
				date_modified = FROM_UNIXTIME(lastupdated)",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("gallery")."
				DROP COLUMN creationtime,
				DROP COLUMN lastupdated
				", __FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("gallery_item")."
					CHANGE COLUMN gallerylink gallery_id SMALLINT (5) UNSIGNED NOT NULL,
					CHANGE COLUMN thumbnail thumbnail_url VARCHAR (255),
					CHANGE COLUMN thumbnailsize thumbnail_size VARCHAR (32),
					CHANGE COLUMN mediaurl media_url VARCHAR (255),
					CHANGE COLUMN mediasize media_size VARCHAR (32),
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime,
					ADD COLUMN date_modified TIMESTAMP(19) AFTER date_created,
					CHANGE COLUMN allowcomments allow_comments ENUM('0','1') NOT NULL default '1'
				", __FILE__, __LINE__);


				$db->query("UPDATE ".db_table("gallery_item")." SET
				date_created = FROM_UNIXTIME(creationtime),
				date_modified = FROM_UNIXTIME(lastupdated)",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("gallery_item")."
				DROP COLUMN creationtime,
				DROP COLUMN lastupdated
				", __FILE__, __LINE__);

			}
		}
		function ext_uninstall($module) {

		}
	}
?>